﻿<?xml version="1.0" encoding="utf-8" ?>
<ContentPage xmlns="http://xamarin.com/schemas/2014/forms"
             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
             xmlns:d="http://xamarin.com/schemas/2014/forms/design"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
             xmlns:iconize="clr-namespace:Plugin.Iconize;assembly=Plugin.Iconize" 
             xmlns:controls="clr-namespace:Demeterre.Codes.Controls"
             xmlns:views="clr-namespace:Demeterre.Views"
             mc:Ignorable="d"
             x:Class="Demeterre.Views.AccueilPage"
             x:Name="Accueil"
             BackgroundColor="{StaticResource AppWhiteBackgroundColor}">

    <ContentPage.Content>

        <Grid RowSpacing="10">

            <Grid.RowDefinitions>
                <RowDefinition Height="*"/>
                <RowDefinition Height="Auto"/>
                <RowDefinition Height="Auto"/>
            </Grid.RowDefinitions>

            <!--Produit de la semaine / rechercher-->
            <Grid Grid.Row="0"
                  IsVisible="{Binding IsAccueil}"
                  Margin="15,0">

                <Grid.RowDefinitions>
                    <RowDefinition Height="*"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="*"/>
                </Grid.RowDefinitions>

                <!--Titre / btn search-->
                <Grid Grid.Row="1">

                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width="*"/>
                        <ColumnDefinition Width="Auto"/>
                    </Grid.ColumnDefinitions>

                    <Label Grid.ColumnSpan="2"
                           HorizontalOptions="Center"
                           FontFamily="Avenir-Black.ttf#Avenir-Black"
                           Text="Demeterre"
                           FontSize="24"
                           FontAttributes="Bold"
                           TextColor="{StaticResource AppTextBlackColor}"
                    />

                    <iconize:IconButton Grid.Column="1" 
                                        Text="fas-search"
                                        TextColor="{StaticResource AppTextGreyColor}"
                                        FontSize="28"
                                        Command="{Binding SearchCommand}"
                                        Clicked="IconButton_Clicked_4"
                                        BackgroundColor="Transparent"
                    />

                </Grid>

                <!--Image-->
                <Image Grid.Row="2"
                       Source="week_Product.png"
                       Margin="0,20"
                       HorizontalOptions="Center"
                       VerticalOptions="Center"
                />

                <!--Titre produit-->
                <Label Grid.Row="3"
                       HorizontalOptions="Center"
                       Text="{Binding ProduitSemaine}"
                       TextColor="{StaticResource AppTextDarkerGreyColor}"
                       FontSize="30"
                />

                <!--Produit de la semaine-->
                <Label Grid.Row="4"
                       HorizontalOptions="Center"
                       Text="Produit de la semaine"
                       FontSize="16"
                       Opacity="0.8"
                />

            </Grid>

            <!--CarouselView-->
            <CarouselView Grid.Row="1"
                          HeightRequest="180"
                          PeekAreaInsets="110"
                          IsVisible="{Binding IsAccueil}"
                          ItemsSource="{Binding TypeProduitList}">

                <CarouselView.ItemsLayout>
                    <LinearItemsLayout Orientation="Horizontal"
                                       ItemSpacing="15"/>
                </CarouselView.ItemsLayout>

                <CarouselView.ItemTemplate>

                    <DataTemplate>

                        <Frame BackgroundColor="{Binding Lib1}"
                               VerticalOptions="Center"
                               CornerRadius="16"
                               Margin="10,0">

                            <Grid>

                                <Grid.RowDefinitions>
                                    <RowDefinition Height="*"/>
                                    <RowDefinition Height="Auto"/>
                                </Grid.RowDefinitions>

                                <Image Grid.RowSpan="2"
                                       Source="{Binding Lib2}"
                                       HorizontalOptions="Center"
                                       VerticalOptions="Start"
                                       HeightRequest="120"
                                       Margin="0,10,0,0"
                                />

                                <Label Grid.Row="1"
                                       Text="{Binding Lib3}"
                                       FontSize="16"
                                       HorizontalOptions="Center"
                                       Margin="5"
                                       TextColor="{StaticResource AppTextWhiteColor}"
                                />

                                <Button Grid.RowSpan="2"
                                        BackgroundColor="Transparent"
                                        Margin="-5"
                                        Command="{Binding BindingContext.RaccourciCommand, Source={x:Reference Accueil}}"
                                        CommandParameter="{Binding Lib4}"/>
                            </Grid>

                        </Frame>

                    </DataTemplate>

                </CarouselView.ItemTemplate>

            </CarouselView>

            <!--ParametreView-->
            <views:ParametreView Grid.RowSpan="2"
                                 Opacity="0"
                                 x:Name="parametre"
                                 IsVisible="{Binding IsParametre}"/>

            <!--PanierView-->
            <views:PanierView Grid.RowSpan="2"
                              Opacity="0"
                              x:Name="panier"
                              IsVisible="{Binding IsPanier}"/>

            <!--Map-->
            <Grid Grid.RowSpan="2"
                  BackgroundColor="{StaticResource AppTextWhiteColor}"
                  Opacity="0"
                  IsVisible="{Binding IsBioRapide}"
                  x:Name="map">

                <Grid.RowDefinitions>
                    <RowDefinition Height="80"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="*"/>
                </Grid.RowDefinitions>

                <Label Grid.Row="0"
                       HorizontalOptions="Center"
                       VerticalOptions="Center"
                       Text="Producteurs à proximité"
                       IsVisible="{Binding IsSelectedProd, Converter={StaticResource Inverse_Boolean}}"
                       TextColor="{StaticResource AppTextDarkerGreyColor}"
                       FontFamily="Avenir-Black.ttf#Avenir-Black"
                       FontSize="20"
                />

                <controls:ExtendedMap Grid.RowSpan="2"
                                      Grid.Row="1"
                                      IsShowingUser="True"
                                      HorizontalOptions="FillAndExpand"
                                      VerticalOptions="FillAndExpand"
                                      MapPosition="{Binding Loc}" 
                                      IsVisible="{Binding IsSelectedProd, Converter={StaticResource Inverse_Boolean}}"
                                      MapClicked="ExtendedMap_MapClicked"
                                      MapPins="{Binding PinCollection}" >
                </controls:ExtendedMap>
                
                <!-- Bio Rapide -->
                <Label Grid.Row="0"
                       HorizontalOptions="Center"
                       VerticalOptions="Center"
                       Text="Bio rapide"
                       Margin="0,20,0,0"
                       IsVisible="{Binding IsSelectedProd}"
                       TextColor="{StaticResource AppTextDarkerGreyColor}"
                       FontFamily="Avenir-Black.ttf#Avenir-Black"
                       FontSize="20"
                />

                <Frame Grid.Row="1"
                       IsVisible="{Binding IsSelectedProd}"
                       CornerRadius="30"
                       Margin="10,0"
                       Padding="0">

                    <Grid Padding="10">

                        <Grid.ColumnDefinitions>
                            <ColumnDefinition Width="*"/>
                            <ColumnDefinition Width="*"/>
                            <ColumnDefinition Width="*"/>
                            <ColumnDefinition Width="*"/>
                        </Grid.ColumnDefinitions>

                        <Frame Grid.Column="0"
                               CornerRadius="20"
                               BackgroundColor="{Binding MainColor}"
                               IsVisible="{Binding IsTous}" />

                        <Grid Grid.Column="0">

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextGreyColor}"
                                   Text="Tous"
                                   FontSize="16"
                            />

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextWhiteColor}"
                                   Text="Tous"
                                   IsVisible="{Binding IsTous}"
                                   FontSize="16"
                            />

                            <Button Command="{Binding OpenTousCommand}"/>

                        </Grid>

                        <Frame Grid.Column="1"
                               CornerRadius="20"
                               BackgroundColor="{Binding MainColor}"
                               IsVisible="{Binding IsBox}" />

                        <Grid Grid.Column="1">

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextGreyColor}"
                                   Text="Box"
                                   FontSize="16"
                            />

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextWhiteColor}"
                                   Text="Box"
                                   FontSize="16"
                                   IsVisible="{Binding IsBox}"
                            />

                            <Button Command="{Binding OpenBoxCommand}"/>

                        </Grid>

                        <Frame Grid.Column="2"
                               CornerRadius="20"
                               BackgroundColor="{Binding MainColor}"
                               IsVisible="{Binding IsFruit}" />

                        <Grid Grid.Column="2">

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextGreyColor}"
                                   Text="Fruits"
                                   FontSize="16"
                            />

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextWhiteColor}"
                                   Text="Fruits"
                                   IsVisible="{Binding IsFruit}"
                                   FontSize="16"
                            />

                            <Button Command="{Binding OpenFruitCommand}"/>

                        </Grid>

                        <Frame Grid.Column="3"
                               CornerRadius="20"
                               BackgroundColor="{Binding MainColor}"
                               IsVisible="{Binding IsLegume}" />

                        <Grid Grid.Column="3">

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextGreyColor}"
                                   Text="Légumes"
                                   FontSize="16"
                            />

                            <Label HorizontalOptions="Center"
                                   TextColor="{StaticResource AppTextWhiteColor}"
                                   Text="Légumes"
                                   IsVisible="{Binding IsLegume}"
                                   FontSize="16"
                            />

                            <Button Command="{Binding OpenLegumeCommand}"/>

                        </Grid>

                    </Grid>

                </Frame>

                <Label Text="Il n'y a pas de box pour le moment, veuillez attendre la prochaine mise à jour !"
                       Grid.Row="2"
                       VerticalOptions="Center"
                       HorizontalOptions="Center"
                       HorizontalTextAlignment="Center"
                       IsVisible="{Binding IsBox}"
                       FontSize="14"
                       FontFamily="Avenir-Medium.ttf#Avenir-Medium"/>

                <CollectionView Grid.Row="2"
                                IsVisible="{Binding IsSelectedProd}"
                                ItemsSource="{Binding ProductDisplayedList}"
                                SelectionMode="Single"
                                SelectedItem="{Binding SelectedProduit, Mode=TwoWay}"
                                Margin="10,20,10,0">

                    <CollectionView.ItemsLayout>
                        <GridItemsLayout Orientation="Vertical"
                                         Span="3"
                                         HorizontalItemSpacing="10"/>
                    </CollectionView.ItemsLayout>

                    <CollectionView.ItemTemplate>

                        <DataTemplate>

                            <Frame CornerRadius="30"
                                   BorderColor="LightGray"
                                   HorizontalOptions="StartAndExpand"
                                   VerticalOptions="StartAndExpand"
                                   Padding="0"
                                   Margin="10,0">

                                <Grid RowSpacing="5"
                                      Margin="5">

                                    <Grid.RowDefinitions>
                                        <RowDefinition Height="Auto"/>
                                        <RowDefinition Height="Auto"/>
                                        <RowDefinition Height="Auto"/>
                                    </Grid.RowDefinitions>

                                    <Image Grid.Row="0"
                                           HorizontalOptions="Center"
                                           VerticalOptions="Center"
                                           HeightRequest="40"
                                           Margin="0,20,0,0"
                                           Source="{Binding Lib1}" />

                                    <Label Grid.Row="1"
                                           Text="{Binding Lib2}"
                                           TextColor="{StaticResource AppTextGreyColor}"
                                           HorizontalOptions="Center"
                                           VerticalOptions="Center"
                                           FontSize="16"
                                    />

                                </Grid>

                            </Frame>

                        </DataTemplate>

                    </CollectionView.ItemTemplate>

                </CollectionView>

            </Grid>

            <!--Recherche-->
            <Grid Grid.RowSpan="3"
                  BackgroundColor="{StaticResource AppTextWhiteColor}"
                  Opacity="0"
                  IsVisible="{Binding IsSearch}"
                  x:Name="search">

                <Grid.RowDefinitions>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="*"/>
                </Grid.RowDefinitions>

                <Label Grid.Row="0"
                       Text="Recherche"
                       TextColor="{StaticResource AppTextDarkerGreyColor}"
                       HorizontalOptions="Center"
                       VerticalOptions="Center"
                       FontFamily="Avenir-Black.ttf#Avenir-Black"
                       FontSize="24"
                       Margin="0,20,0,0"/>

                <iconize:IconButton Grid.Row="0"
                                    Text="fas-times"
                                    TextColor="{StaticResource AppTextDarkerGreyColor}"
                                    HorizontalOptions="End"
                                    VerticalOptions="Center"
                                    BackgroundColor="Transparent"
                                    Margin="0,20,0,0"
                                    FontSize="22"
                                    Clicked="IconButton_Clicked_5"/>

                <Frame Grid.Row="1"
                       CornerRadius="50"
                       BackgroundColor="Transparent"
                       HasShadow="True"
                       Margin="15,20">

                    <SearchBar Placeholder="Qu'est ce que vous cherchez ?"
                               PlaceholderColor="{StaticResource AppTextGreyColor}"
                               VerticalOptions="Center"
                               Text="{Binding SearchValue}"/>
                </Frame>

            </Grid>

            <!--Menu-->
            <Grid Grid.Row="2"
                  VerticalOptions="End"
                  Margin="15,10">

                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="*"/>
                    <ColumnDefinition Width="*"/>
                    <ColumnDefinition Width="Auto"/>
                    <ColumnDefinition Width="*"/>
                    <ColumnDefinition Width="*"/>
                </Grid.ColumnDefinitions>

                <iconize:IconButton Grid.Column="0"
                                    Text="fas-home"
                                    TextColor="{StaticResource AppTextGreyColor}"
                                    IsVisible="{Binding IsAccueil, Converter={StaticResource Inverse_Boolean}}"
                                    BackgroundColor="Transparent"
                                    FontSize="20"
                                    Command="{Binding AccueilCommand}"
                />

                <iconize:IconButton Grid.Column="0"
                                    Text="fas-home"
                                    TextColor="{Binding MainColor}"
                                    IsVisible="{Binding IsAccueil}"
                                    BackgroundColor="Transparent"
                                    FontSize="20"
                                    Command="{Binding AccueilCommand}"
                />

                <iconize:IconButton Grid.Column="1"
                                    Text="fas-star"
                                    TextColor="{StaticResource AppTextGreyColor}"
                                    BackgroundColor="Transparent"
                                    FontSize="20"
                                    Command="{Binding BoxAVenirCommand}"
                />

                <Frame Grid.Column="2"
                       HeightRequest="50"
                       Margin="5,0"
                       WidthRequest="50"
                       CornerRadius="100"
                       IsVisible="{Binding IsBioRapide, Converter={StaticResource Inverse_Boolean}}"
                       BackgroundColor="{StaticResource AppTextGreyColor}">

                    <iconize:IconButton Text="fas-plus"
                                        TextColor="{StaticResource AppTextWhiteColor}"
                                        BackgroundColor="Transparent"
                                        FontSize="22"
                                        Clicked="IconButton_Clicked"
                                        Command="{Binding OpenBioRapideCommand}"
                    />

                </Frame>

                <Frame Grid.Column="2"
                       HeightRequest="50"
                       Margin="5,0"
                       WidthRequest="50"
                       CornerRadius="100"
                       IsVisible="{Binding IsBioRapide}"
                       BackgroundColor="{Binding MainColor}">

                    <iconize:IconButton Text="fas-times"
                                        TextColor="{StaticResource AppTextWhiteColor}"
                                        BackgroundColor="Transparent"
                                        FontSize="22"
                                        Clicked="IconButton_Clicked_1"
                    />

                </Frame>

                <Grid Grid.Column="3"
                      Margin="0,10,5,0">

                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width="*"/>
                        <ColumnDefinition Width="25"/>
                    </Grid.ColumnDefinitions>

                    <Grid.RowDefinitions>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="25"/>
                    </Grid.RowDefinitions>

                    <iconize:IconButton Grid.ColumnSpan="2"
                                        Grid.RowSpan="3"
                                        Text="fas-shopping-cart"
                                        Margin="5,0,0,0"
                                        TextColor="{Binding MainColor}"
                                        IsVisible="{Binding IsPanier}"
                                        BackgroundColor="Transparent"
                                        FontSize="20"
                                        Command="{Binding PanierCommand}"
                        />

                    <iconize:IconButton Grid.ColumnSpan="2"
                                        Grid.RowSpan="3"
                                        Margin="5,0,0,0"
                                        Text="fas-shopping-cart"
                                        TextColor="{StaticResource AppTextGreyColor}"
                                        BackgroundColor="Transparent"
                                        IsVisible="{Binding IsPanier, Converter={StaticResource Inverse_Boolean}}"
                                        FontSize="20"
                                        Clicked="IconButton_Clicked_2"
                                        Command="{Binding PanierCommand}"
                         />

                    <Frame BackgroundColor="{Binding MainColor}"
                           CornerRadius="250" 
                           Margin="0,5,5,0"
                           Grid.Row="2"
                           Grid.Column="1">

                        <Label Text="{Binding CountProdPanier}"
                               TextColor="{StaticResource AppWhiteBackgroundColor}"
                               HorizontalOptions="Center"
                               VerticalOptions="Center"
                               Margin="-10"/>
                    </Frame>

                </Grid>

                <iconize:IconButton Grid.Column="4"
                                    Text="fas-cog"
                                    TextColor="{StaticResource AppTextGreyColor}"
                                    BackgroundColor="Transparent"
                                    IsVisible="{Binding IsParametre, Converter={StaticResource Inverse_Boolean}}"
                                    FontSize="20"
                                    Clicked="IconButton_Clicked_3"
                                    Command="{Binding ParametresCommand}"
                />

                <iconize:IconButton Grid.Column="4"
                                    Text="fas-cog"
                                    TextColor="{Binding MainColor}"
                                    IsVisible="{Binding IsParametre}"
                                    BackgroundColor="Transparent"
                                    FontSize="20"
                                    Command="{Binding ParametresCommand}"
                />

            </Grid>

            <controls:BusyView Grid.RowSpan="3"/>

        </Grid>

    </ContentPage.Content>

</ContentPage>